module ApiTransformer
  module Rack
    # Parses out cookies and make them available as request parameters
    class CookieParams
      # Cookie string parser
      module Parser
        def cookie_params(env)
          cookie_string = env["HTTP_COOKIE"]

          if cookie_string
            cookie_pairs = cookie_string.split(/\s*;\s*/)

            cookie_pairs.reduce({}) do |hash, pair|
              key, value = pair.split("=")
              hash.merge(key => value)
            end
          else
            {}
          end
        end
      end

      include Goliath::Rack::Validator
      include Parser

      def initialize(app)
        @app = app
      end

      def call(env)
        Goliath::Rack::Validator.safely(env) do
          env["params"].merge!(cookie_params(env))
          @app.call(env)
        end
      end
    end
  end
end
