require "ostruct"

module ApiTransformer
  # A route
  class Route < OpenStruct
    # For passing back a header and status
    class Response < Struct.new(:status, :headers); end

    def run(base_url, params, env)
      indifferent_params = Params.try_convert(params)
      endpoint = Endpoint.new(base_url, env, self)
      headers = env["client-headers"]

      helper_blocks.each { |block| endpoint.instance_eval(&block) }
      endpoint.instance_exec(indifferent_params, headers, &self.block)

      status, headers = endpoint.run

      EM.next_tick do
        endpoint.complete
      end

      Response.new(status, headers)
    end
  end
end
